import numpy as np

def Cauchy(m, n):
    x = np.array(xrange(n + 1, n + m + 1))
    y = np.array(xrange(1, n + 1))
    x = x.reshape((-1, 1))
    diff_matrix = x - y
    cauchym = 1.0 / diff_matrix
    return cauchym


def Vandermonde(k, delta):
    M = np.zeros((k, k))
    for i in xrange(k):
        for j in xrange(k):
            M[i, j] = delta[i] ** j
    return M


def RS(n, k):
    I = np.identity(k)
    P = Cauchy(n - k, k)
    return np.concatenate((I, P), axis = 0)


def decode(M, G, origin):
        G = np.linalg.inv(G)
        G = G[range(origin), :]
        return np.dot(G, M)
        # return multiply(M, G)
    # else:
        # X = np.linalg.solve(G, M)
        # return X


def multiply(M, G):
    count = 0
    D = M[0].shape
    X = 1
    Y = D[-1]
    N, K = G.shape
    R = np.zeros((N, X, Y))
    for i in xrange(N):
        # print G[i]
        for j in xrange(K):
                R[i] = R[i] + G[i, j] * M[j]
                count += 1
    logging.info(" matrix multiplication: %d" % (count,))
    return R
